import pygame as pg

pg.init()
my_font = pg.font.SysFont(None,34)
screen = pg.display.set_mode(size=(1000,500))    #   表示画面
sf = pg.Surface((800,200))          #    刺激表示サーフェス
pa = pg.PixelArray(sf)              #    サーフェスに対応するピクセル配列
vd = 10                             #     境界領域の輝度差
ck = True
while ck:
    #
    #        画面全体を白で塗りつぶす
    #
    screen.fill((255,255,255))
    pg.display.flip()
    #
    #            輝度差vdの表示
    #
    img_str = my_font.render(f'vd = {vd}', True, (0,0,0), (255,255,255))
    rect_str = img_str.get_rect()
    screen.blit(img_str, (500 - rect_str.width//2, 500 - rect_str.height*2))
    #
    #         提示刺激パターンの描画
    #
    pa[:200] = (100,100,100)                #   左1／4を灰色で塗り潰す
    for ix in range(200,400):               #   中央左側を変化率vd/200で塗り潰す
        v = 100 + int(vd * (ix - 200) / 200)
        pa[ix] = (v,v,v)
    for ix in range(400,600):               #   中央右側を変化率-vd/200で塗り潰す
        v = 100 - vd + int(vd * (ix - 400) / 200)
        pa[ix] = (v,v,v)
    pa[600:800] = (100,100,100)             #   右1／4を灰色で塗り潰す
 
    sf = pg.PixelArray.make_surface(pa)     #   ピクセル配列をサーフェスに変換
    screen.blit(sf, (100,100))              #   サーフェスをスクリーンに移す
    pg.display.flip()                       #   ディスプレイ画面の更新

    ck0 = True
    while ck0:
        for e in pg.event.get():
            if e.type == pg.KEYDOWN:
                if e.key == pg.K_q:         #    「キーQ」が押されたか？
                    ck0 = False             #    このwhile文を抜け出す
                    ck = False              #    外側のwhile文を抜け出す
                elif e.key == pg.K_u:       #    「キーU」が押されたか？
                    ck0 = False
                    if vd < 70:
                        vd += 1             #    vdの更新
                elif e.key == pg.K_d:       #    「キーD」が押されたか？
                    ck0 = False
                    if vd > -70:
                        vd -= 1             #     vdの更新
                        
        pg.time.wait(10)                    #    10msの待機


pg.quit()                                   #   PyGameの終了
